/********************************************************************
	Module	:	dialserv.h
	Purpose	:	class definitions for Implementation of
				Dialer DDE support.
	Author	:	Gregory A. Crandell
	History	:	Created 2/5/95
\*******************************************************************/

#ifndef _DDEDIALER
#define _DDEDIALER

// DDE Verb definitions
#define	DIALER_CONNECTED					101
#define DIALER_NOT_CONNECTED                102
#define DIALER_QUIETMODE_ON                 103
#define DIALER_QUIETMODE_OFF                104


#define DIALER_INITIALIZING					111
#define DIALER_DIALING						112
#define DIALER_MODEMINIT					113
#define DIALER_STACKINIT					114
#define DIALER_DISCONNECTING				115

#define DIALER_USERCANCEL					121
#define DIALER_MANUAL_LOGIN                 122
#define DIALER_AUTO_LOGIN                   123
#define DIALER_LOGIN_FAILED                 124

#define	DIALER_DIAL                         131
#define	DIALER_DIALQUIET                    132
#define	DIALER_CANCELDIAL                   133
#define	DIALER_MODEMHANGUP                  134
#define	DIALER_MODEMHANGUPQUIET             135
#define DIALER_SHUTDOWN						136   
#define	DIALER_SHUTDOWNQUIET                137
#define	DIALER_INICHANGE                    138


#define DIALER_POST_DIALMODE                141
#define DIALER_POST_DIALSTATE               142
#define DIALER_TOGGLE_QUIETMODE             143
#define DIALER_TOGGLE_DASHBOARD             144
//#define DIALER_TOGGLE_PACKETMODE          145


#define	DIALER_ERR_MODEM_BUSY				171
#define DIALER_ERR_MODEM_NOCARRIER			172
#define DIALER_ERR_MODEM_NODIALTONE			173
#define	DIALER_ERR_MODEM_NOANSWER			174
#define DIALER_ERR_MODEM_VOICE				175
#define DIALER_ERR_MODEM_NONUMBER			176
#define DIALER_ERR_MODEM_ERROR				179


#define DIALER_ERR_COMMPORT_SETTINGS        191
#define DIALER_ERR_COMMPORT_INVALID         192
#define DIALER_ERR_COMMPORT_INUSE           193
#define DIALER_ERR_COMMPORT_NOMODEM         194
#define DIALER_ERR_COMMPORT_FAILURE         199

				
// error codes
#define DDESPY_NO_ERROR						0
#define DDESPY_CANNOT_ALLOCATE_PARSER		1
#define DDESPY_ERROR_NO_MORE_TOKENS 		2
#define DDESPY_ERROR_DATA_TYPE				3
#define DDESPY_ERROR_DOCUMENT_LOAD			4
#define DDESPY_ERROR_CONNECT				5
#define DDESPY_ERROR_CREATE_STRING_HANDLE	6
#define DDESPY_ERROR_CLIENT_TRANSACTION		7
#define DDESPY_ERROR_CREATE_VIEW			8
#define DDESPY_ERROR_NO_SERVICE_NAME		9
#define DDESPY_ERROR_NO_DATA				10
#define DDESPY_ERROR_NO_MAIN_WINDOW			11
#define DDESPY_ERROR_CREATE_CMYMSG			12
#define DDESPY_ERROR_CREATE_MEMORY			13
#define DDESPY_ERROR_NO_TOPIC				14
#define DDESPY_ERROR_CANNOT_ALLOC_MEMORY	15



// misc definitions
#define DDE_TRANS_TIMEOUT					60000 /*TIMEOUT_ASYNC*/


class CDialerServ : public CDDEService
{
private:
	LASTERROR		m_nLastError;	 	// last known error
	CString	*		m_pcsProgressServ;
public:
				CDialerServ		( char * szServiceName );
	virtual		~CDialerServ	( );

	void		Destroy			( );
   	BOOL	  	HasTopic		( const char * pszTopic );		// get topic 
   	BOOL		HasTopic		( int nTopicId );
//	LASTERROR	TranslateError	( LASTERROR nLastError );

protected:
	LASTERROR		Init			( char * szServiceName );
	HDDEDATA		Dispatch		( HDDEDATA hDataOut, HSZ hszItem, HSZ hszTopic, WORD wType );
	BOOL			DeliverMsg		( LPARAM lData, unsigned int uTransType, DWORD dwTimeOut );
	HDDEDATA		Register		( HDDEDATA hDataOut, char * szItem );
	void virtual	Post			( LPARAM lData );
	void virtual	PostData		( int nData );
};

#endif
